import _useEffectState3 from "parsec-hooks/lib/effectStateHooks";
import _useLoadMore2 from "parsec-hooks/lib/loadMoreHooks";
var _excluded = ["getList", "renderItem", "cacheKey", "noData", "noMore", "loadingTip", "renderItemHeight", "className", "style", "defaultLimit"];

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { forwardRef, useImperativeHandle, useEffect, useMemo, useRef, useCallback, useState } from 'react';
import Visible from '../visible';
import NoData from '../no-data';
import Loading from '../loading';
import Button from '../button';
import Native from '../native';
var List = /*#__PURE__*/forwardRef( // eslint-disable-next-line @typescript-eslint/ban-types
function (_ref, ref) {
  var getList = _ref.getList,
      renderItem = _ref.renderItem,
      _ref$cacheKey = _ref.cacheKey,
      cacheKey = _ref$cacheKey === void 0 ? process.env.REMAX_PLATFORM === 'wechat' ? // eslint-disable-next-line
  // @ts-ignore
  getCurrentPages()[getCurrentPages().length - 1].pageId : window.location.pathname : _ref$cacheKey,
      _ref$noData = _ref.noData,
      noData = _ref$noData === void 0 ? useMemo(function () {
    return /*#__PURE__*/React.createElement(NoData, null);
  }, []) : _ref$noData,
      noMore = _ref.noMore,
      loadingTip = _ref.loadingTip,
      renderItemHeight = _ref.renderItemHeight,
      className = _ref.className,
      style = _ref.style,
      _ref$defaultLimit = _ref.defaultLimit,
      defaultLimit = _ref$defaultLimit === void 0 ? 10 : _ref$defaultLimit,
      options = _objectWithoutProperties(_ref, _excluded);

  var loadingNativeRef = useRef(null);
  var noLoadingNativeRef = useRef(null);

  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      visible = _useState2[0],
      setVisible = _useState2[1];

  var _useLoadMore = _useLoadMore2(getList, _objectSpread(_objectSpread({
    cacheKey: cacheKey,
    loadMoreVisible: visible,
    defaultLimit: defaultLimit
  }, options), {}, {
    customSetLoading: useCallback(function (loading) {
      var _loadingNativeRef$cur, _loadingNativeRef$cur2, _noLoadingNativeRef$c, _noLoadingNativeRef$c2;

      (_loadingNativeRef$cur = loadingNativeRef.current) === null || _loadingNativeRef$cur === void 0 ? void 0 : (_loadingNativeRef$cur2 = _loadingNativeRef$cur.setData) === null || _loadingNativeRef$cur2 === void 0 ? void 0 : _loadingNativeRef$cur2.call(_loadingNativeRef$cur, {
        visible: loading
      });
      (_noLoadingNativeRef$c = noLoadingNativeRef.current) === null || _noLoadingNativeRef$c === void 0 ? void 0 : (_noLoadingNativeRef$c2 = _noLoadingNativeRef$c.setData) === null || _noLoadingNativeRef$c2 === void 0 ? void 0 : _noLoadingNativeRef$c2.call(_noLoadingNativeRef$c, {
        visible: !loading
      });
    }, [])
  })),
      refreshList = _useLoadMore.refreshList,
      list = _useLoadMore.list,
      isEnd = _useLoadMore.isEnd,
      error = _useLoadMore.error,
      getNext = _useLoadMore.getNext;

  var _useEffectState = _useEffectState3(error),
      _useEffectState2 = _slicedToArray(_useEffectState, 2),
      showError = _useEffectState2[0],
      setShowError = _useEffectState2[1];

  useImperativeHandle(ref, function () {
    return {
      refreshList: refreshList
    };
  });
  useEffect(function () {
    if (error) {
      console.error(error);
    }
  }, [error]);
  loadingTip = useMemo(function () {
    return loadingTip || /*#__PURE__*/React.createElement(Loading, {
      type: 'inline'
    });
  }, [loadingTip]);
  var footer = useMemo(function () {
    return /*#__PURE__*/React.createElement(Visible, {
      onVisible: function onVisible() {
        getNext();
        setVisible(true);
      },
      onHidden: function onHidden() {
        return setVisible(false);
      }
    }, /*#__PURE__*/React.createElement(Native, {
      ref: loadingNativeRef
    }, loadingTip), /*#__PURE__*/React.createElement(Native, {
      ref: noLoadingNativeRef,
      initData: {
        visible: false
      }
    }, list.length === 0 ? noData || noMore || loadingTip : isEnd ? noMore || noData : loadingTip));
  }, [getNext, isEnd, list.length, loadingTip, noData, noMore]);
  var list2 = useMemo(function () {
    var result = [];
    list.forEach(function (_, i) {
      if (!(i % defaultLimit)) {
        result.push(_toConsumableArray(list).slice(i, i + defaultLimit));
      }
    });
    return result;
  }, [defaultLimit, list]);
  return useMemo(function () {
    return /*#__PURE__*/React.createElement(React.Fragment, null, showError ? /*#__PURE__*/React.createElement(Button, {
      onTap: function onTap() {
        setShowError(false);
        refreshList();
      },
      style: {
        margin: '20px auto'
      }
    }, "\u52A0\u8F7D\u5931\u8D25\uFF0C\u70B9\u51FB\u91CD\u8BD5") : renderItemHeight ? /*#__PURE__*/React.createElement(React.Fragment, null, list2.map(function (items, index) {
      var height = 0;
      items.forEach(function (item, i) {
        height += renderItemHeight(item, index * defaultLimit + i);
      });
      return /*#__PURE__*/React.createElement(Visible, {
        key: index,
        height: height,
        perf: true
      }, items.map(function (data, i) {
        return renderItem(data, index * defaultLimit + i, list);
      }));
    }), footer) : /*#__PURE__*/React.createElement(React.Fragment, null, list.map(function (data, index) {
      return renderItem(data, index, list);
    }), footer));
  }, [defaultLimit, footer, list, list2, refreshList, renderItem, renderItemHeight, setShowError, showError]);
});
export default List;